eCoords_Options =
{
	show = true,
	lock = false,
	tooltip = true,
	worldmap = true,
	alpha = 1
};

function eCoords_Message(msg)
	DEFAULT_CHAT_FRAME:AddMessage("[eCoords] "..msg);
end

function eCoords_OnLoad(self)
	SLASH_ECOORDS1 = "/ecoords";
	SLASH_ECOORDS2 = "/ec";
	SlashCmdList["ECOORDS"] = eCoords_SlashCommand;
end

function eCoords_SlashCommand(msg)
	msg = string.lower(msg);
	local args = {};
	for word in string.gmatch(msg, "[^%s]+") do
		table.insert(args, word);
	end
	if(args[1])then
		if(args[1] == "options")then
			eCoords_Options_Toggle();
		elseif(args[1] == "show")then
			eCoords_Toggle();
		elseif(args[1] == "lock")then
			eCoords_Options.lock = not eCoords_Options.lock;
		elseif(args[1] == "tooltip")then
			eCoords_Options.tooltip = not eCoords_Options.tooltip;
		elseif(args[1] == "worldmap")then
			eCoords_WorldMap_Toggle();
		elseif(args[1] == "alpha")then
			local alpha = tonumber(args[2])
			if((alpha) and alpha >= 0 and alpha <= 1)then
				eCoords_Options.alpha = alpha;
				eCoords_Frame:SetAlpha(alpha);
			else
				eCoords_Message(ECOORDS_OPTIONS_ALPHAWRONG);
			end
		else
			eCoords_Message(ECOORDS_NOCOMMAND);	
		end
	else
		eCoords_Message(ECOORDS_USAGE);
		eCoords_Message("options - under development");
		eCoords_Message("show - "..ECOORDS_OPTIONS_SHOW);
		eCoords_Message("lock - "..ECOORDS_OPTIONS_LOCK);
		eCoords_Message("tooltip - "..ECOORDS_OPTIONS_TOOLTIP);
		eCoords_Message("worldmap - under development");
		eCoords_Message("alpha <#> - "..ECOORDS_OPTIONS_ALPHA);
	end
end

function eCoords_Toggle()
	if(eCoords_Frame:IsShown())then
		eCoords_Frame:Hide();
	else
		eCoords_Frame:Show();
	end
end

local function round(num, idp)
	local mult = 10 ^ (idp or 0);
	return math.floor(num * mult + 0.5) / mult;
end

function eCoords_OnUpdate(self, elapsed)
	local x, y = GetPlayerMapPosition("player");
	local text;
	if(x == 0 and y == 0)then
		text = "--";
	else
		x = round(x * 100, 2);
		y = round(y * 100, 2);
		text = string.format("%.2f, %.2f", x, y);
	end
	eCoords_Frame_Text:SetText(text);
	getglobal(self:GetName().."_Text"):SetText(text);
end

function eCoords_OnEnter(self)
	if(eCoords_Options.tooltip)then
		GameTooltip_SetDefaultAnchor(GameTooltip, self);
		GameTooltip:SetText(ECOORDS_TOOLTIP_TITLE);
		GameTooltip:AddLine(ECOORDS_TOOLTIP_SUBTITLE);
		if(eCoords_Options.lock)then
			GameTooltip:AddLine(ECOORDS_TOOLTIP_LOCKED);
		else
			GameTooltip:AddLine(ECOORDS_TOOLTIP_LEFTCLICK);
		end
		GameTooltip:AddLine(ECOORDS_TOOLTIP_RIGHTCLICK);
		GameTooltipTextLeft1:SetTextColor(1, 1, 1);
		GameTooltipTextLeft2:SetTextColor(1, 1, 1);
		GameTooltip:Show();
	end
end

function eCoords_WorldMap_Toggle()
	if(eCoords_WorldMap_Frame:IsShown())then
		eCoords_WorldMap_Frame:Hide();
		eCoords_Options.worldmap = false;
	else
		eCoords_WorldMap_Frame:Show();
		eCoords_Options.worldmap = true;
	end
end